#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<double, double> pdd;

const double PI = 3.1415926535897932384626433832795;


double mySqrt(double x) {
	if (x < 0) return 0;
	return sqrt(x);
}

double calc(const vector<pdd>& v) {
	vector<pair<double, int> > r;
	forn(i, sz(v)) r.pb(mp(v[i].X, 0)), r.pb(mp(v[i].Y, 1));
	sort(ALL(r));
	double st = -1e9;
	int bal = 0;
	double best = -1;
	forn(i, sz(r)) {
		if (r[i].Y == 0) bal++; else bal--;
		if (bal == 0) {
			double curans = r[i].X-st;
			best = max(best, curans);
		}
		if (r[i].Y == 0 && bal == 1) st = r[i].X;
	}
	return best;
}

bool solve() {
	int n; scanf("%d", &n);
	if (n == 0) return false;
	vector<int> xx(n);
	vector<int> R(n);
	forn(i, n) scanf("%d%d", &xx[i], &R[i]);
	double l = 0;
	double r = 1e6;
	forn(iter, 40) {
		double m = (l+r)*.5;
		vector<pdd> v;
		forn(i, n) {
			double curx = xx[i];
			double p = mySqrt(R[i]*(double)R[i] - m*m);
			if (p == 0) continue;
			double lf = curx - p;
			double rg = curx + p;
			v.pb(mp(lf, rg));
		}
		double tt = calc(v);
		if (tt >= 2 * m) l = m;
		else r = m;
	}
	printf("%.15lf\n", l*2);
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	while (solve());
	return 0;
}
