#include <set>
#include <map>
#include <cmath>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = 1<<17;
const int inf = 1<<30;
const double eps = 1e-7;

int n, x[N], r[N], R;
double ans;

bool inside(double xx, double yy, int i) {
	return (xx-x[i])*(xx-x[i]) + yy*yy <= r[i]*1.0*r[i] - eps;
}

void solve() {
	for (int i = 0; i < n; i++)
		scanf("%d %d", x + i, r + i);

	R = 0;
	for (int i = 0; i < n; i++) {
		R = max(R, r[i]);
	}

	ans = 2*R/sqrt(2.0);

	for (int i = 0; i + 1 < n; i++) {
		double p = (r[i] + r[i+1] + x[i+1] - x[i]) / 2.0;
		double h = 2*sqrt(p*(p-r[i]))*sqrt((p-r[i+1])*(p-x[i+1]+x[i]))/(x[i+1]-x[i]);
		double l = 0, R = h, cur = 0;
		for (int it = 0; it < 35; it++) {
			double mid = (l + R) / 2;
			double shl = sqrt(r[i]*1.0*r[i]-mid*mid);
			double shr = sqrt(r[i+1]*1.0*r[i+1]-mid*mid);
			bool ok = false;
			for (int j = i; j < n && j < i + 12; j++) {
				if (inside(x[i] - shl + 2 * mid,mid,j)) {
					ok = true;
					break;
				}
			}
			/*if (!ok)
			for (int j = i; j >= 0 && j > i - 10; j--) {
				if (inside(x[i + 1] + shr - 2 * mid,mid,j)) {
					ok = true;
					break;
				}
			}*/
			if (ok) {
				cur = mid;
				l = mid;
			} else {
				R = mid;
			}
		}
		ans = max(ans, cur*2);
	}

	printf("%.12lf\n", ans);
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	while (1) {
		scanf("%d", &n);
		if (n == 0) break;
		solve();
	}
	return 0;
}
