#include <set>
#include <map>
#include <cmath>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <sstream>
using namespace std;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 20000

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = 1<<17;
const int inf = 1<<30;

double doit(string s) {
	stringstream ss(s);
	double x; 
	ss >> x;
	return x;
}

vector<double> make(vector<double> a, vector<double> b) {
	if (sz(a) == 2 && sz(b) == 2) {
		a.pb(b[0]);
		a.pb(b[1]);
		return a;
	}
	if (sz(a) == 4 && sz(b) == 2) swap(a,b);
	if (sz(a) == 2 && sz(b) == 4) {
		double A = b[1] - b[3];
		double B = b[2] - b[0];
		double C = -A * b[0] - B * b[1];
		double D = (A * a[0] + B * a[1] + C) / sqrt(A * A + B * B);
		double len = sqrt(A * A + B * B);
		double vx = -A / len;
		double vy = -B / len;
		vector<double> res = a;
		res[0] += 2 * vx * D;
		res[1] += 2 * vy * D;
		return res;
	}
	if (sz(a) == 4 && sz(b) == 4) {
		double A1 = b[1] - b[3];
		double B1 = b[2] - b[0];
		double C1 = -A1 * b[0] - B1 * b[1];
		double A2 = a[1] - a[3];
		double B2 = a[2] - a[0];
		double C2 = -A2 * a[0] - B2 * a[1];
		double vx = (C2 * B1 - C1 * B2) / (A1 * B2 - A2 * B1);
		double vy = (C2 * A1 - C1 * A2) / (B1 * A2 - A1 * B2);
		vector<double> res;
		res.pb(vx);
		res.pb(vy);
		return res;
	}
	assert(false);
}

vector<double> get(string s) {
	int n = sz(s);
	if (s[0] == '(') {
		int cur = 1;
		for (int i = 1; i < n - 1; i++) {
			if (s[i] == '(') cur++;
			if (s[i] == ')') cur--;
			if (cur == 0) break;
		}
		if (cur == 1) return get(s.substr(1,n - 2));
	}
	int cur = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == ')') cur++;
		if (s[i] == '(') cur--;
		if (cur != 0) continue;
		if (s[i] == '@') {
			/*if (i == 11) {
				cout << s.substr(0,i) << " " << s.substr(i + 1) << endl;
			cout << get(s.substr(0,i))[0] << " " << get(s.substr(0,i))[1] << " " <<get(s.substr(0,i))[2] << " " << get(s.substr(0,i))[3] << endl;
			cout << get(s.substr(i + 1))[0] << " " << get(s.substr(i + 1))[1] << endl;
			}*/

		return make(get(s.substr(0,i)),get(s.substr(i + 1)));
		}
	}
	for (int i = 0; i < n; i++) if (s[i] == ',') {
		vector<double> res;
		res.pb(doit(s.substr(0,i)));
		res.pb(doit(s.substr(i + 1)));
		return res;
	}
	assert(false);
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	string s;

	while(getline(cin,s)) {
		if (s == "#") break;
		vector<double> res = get(s);
		printf("%.9lf %.9lf\n",res[0],res[1]);
	}

	return 0;
}
