#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

double check(double w, int n, int pw, vector<int> & vw, vector<int> & pf, vector<int> & vf, vector<int> & th) {
    double cost = w * pw;
    for (int i = 0; i < n; ++i)
        if (w * vw[i] >= th[i]) {
//            cerr << w * vw[i] << " " << th[i] << endl;
            continue;
        }
        else {
            double tmp = (th[i] - w * vw[i]) * 1.0 / vf[i];
//            cerr << "@" << tmp << " " << pf[i] << endl;
            cost += tmp * pf[i];
//            cerr << th[i] << " " << w * vw[i] + tmp * vf[i] << endl;
        }
    return cost;
}

int main() {
    ios_base::sync_with_stdio(false);
    int n;
    while (cin >> n) {
        if (n == 0)
            break;
        int pw;
        cin >> pw;
        vector<int> vw(n), pf(n), vf(n), th(n);
        for (int i = 0; i < n; ++i)
            cin >> vw[i] >> pf[i] >> vf[i] >> th[i];

        double l = 0;
        double r = 1e9;
        for (int it = 0; it < 200; ++it) {
            double m1 = l + (r - l) / 3;
            double m2 = r - (r - l) / 3;
            if (check(m1, n, pw, vw, pf, vf, th) > check(m2, n, pw, vw, pf, vf, th))
                l = m1;
            else r = m2;
        }
//        double l = 1.25;
//        cout << l << endl;
        printf("%.5f\n",check(l, n, pw, vw, pf, vf, th));
//        cerr << check(43.5, n, pw, vw, pf, vf, th) << endl;
    }
}
