#include <iostream>
#include <string>
#include <cstdio>
#include <iomanip>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cstdlib>


using namespace std;

const int MAX_N = 50005;

int main() {
	ios_base::sync_with_stdio(false);
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);

    int n, x[MAX_N], r[MAX_N];

    while (cin >> n) {
        if (n == 0) {
            break;
        }

        double res = 0;

        for (int i = 0; i < n; i++) {
            cin >> x[i] >> r[i];

            res = max(res, sqrt(2.0) * r[i]);
        }

        for (int i = 0; i < n - 1; i++) {
            double p = (r[i] + r[i + 1] + (x[i + 1] - x[i])) / 2.0;
            double h = 2.0 * sqrt(p * (p - r[i]) * (p - r[i + 1]) * (p - (x[i + 1] - x[i]))) / ((double)x[i + 1] - x[i]);
            double dx1 = sqrt((double)r[i] * r[i] - h * h), x1 = x[i] - dx1;
            double dx2 = sqrt((double)r[i + 1] * r[i + 1] - h * h), x2 = x[i + 1] + dx2;
            double dx = x2 - x1, q = (2.0 * h) / dx;

            if (q > 1) {
                continue;
            } else {
                double lo = 0.0, hi = h;

                while (hi - lo > 1e-9) {
                    double mid = (lo + hi) / 2.0;
                    dx1 = sqrt((double)r[i] * r[i] - mid * mid); x1 = x[i] - dx1;
                    dx2 = sqrt((double)r[i + 1] * r[i + 1] - mid * mid); x2 = x[i + 1] + dx2;
                    dx = x2 - x1, q = (2.0 * mid) / dx;

                    if (q < 1.0) {
                        lo = mid;
                    } else {
                        hi = mid;
                    }
                }
                res = max(res, 2 * hi);
            }
        }

        cout << setprecision(8) << fixed << res << endl;
    }

	return 0;
}
