#include <iostream>
#include <string>
#include <cstdio>
#include <iomanip>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cstdlib>


using namespace std;

const int MAX_N = 50005;

int main() {
	ios_base::sync_with_stdio(false);
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);

    int n, x[MAX_N], r[MAX_N];

    while (cin >> n) {
        if (n == 0) {
            break;
        }

        long double res = 0;

        for (int i = 0; i < n; i++) {
            cin >> x[i] >> r[i];

            res = max(res, sqrtl(2.0) * r[i]);
        }

        for (int i = 0; i < n - 1; i++) {
            long double p = (r[i] + r[i + 1] + (x[i + 1] - x[i])) / 2.0;
            long double h = 2.0 * sqrtl(p * (p - r[i]) * (p - r[i + 1]) * (p - (x[i + 1] - x[i]))) / ((long double)x[i + 1] - x[i]);
            long double dx1 = sqrtl((long double)r[i] * r[i] - h * h), x1 = x[i] - dx1;
            long double dx2 = sqrtl((long double)r[i + 1] * r[i + 1] - h * h), x2 = x[i + 1] + dx2;
            long double dx = x2 - x1, q = (2.0 * h) / dx;

            long double lo = 0.0, hi = h;

            while (hi - lo > 1e-14) {
                long double mid = (lo + hi) / 2.0;
                dx1 = sqrtl((long double)r[i] * r[i] - mid * mid); x1 = x[i] - dx1;
                dx2 = sqrtl((long double)r[i + 1] * r[i + 1] - mid * mid); x2 = x[i + 1] + dx2;
                dx = x2 - x1, q = (2.0 * mid) / dx;

                if (q < 1.0) {
                    lo = mid;
                } else {
                    hi = mid;
                }
            }
            res = max(res, 2.0 * hi);
        }

        cout << setprecision(16) << fixed << res << endl;
    }

    return 0;
}
