#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <memory.h>
#include <set>
#include <map>

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define fi first
#define se second
#define mp make_pair
#define pb push_back

#define TASKNAME "coco"

typedef long long i64;
typedef long long li;
typedef long long lint;

using namespace std;

int n, m, q;
char s[100], x[100];
char pred[100];
li res[1010];
li antires[1010];
bool used[1010];

li unmask() {
	li res = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '1')
			res ^= (1LL << i);
	}
	return res;
}

li rev(li msk) {
	li res = 0;
	for (int i = 0; i < n; i++)
		if ((msk & (1 << i)) == 0) 
			res ^= (1 << i);
	return res;
}

void solve() {
	memset(res, 0, sizeof(res));
	memset(antires, 0, sizeof(antires));
	scanf("%d%d%d", &n, &m, &q);
	if (n == 0 && m == 0 && q == 0)
		exit(0);
	for (int i = 0; i < m; i++)
		pred[i] = '0';
	for (int i = 0; i < m; i++)
		res[i] = (1LL << n) - 1;
	for (int ii = 0; ii < q; ii++) {
		scanf("%s %s\n", &s, &x);
		for (int i = 0; i < m; i++) {
			if (x[i] != pred[i]) {
				used[i] = true;
			} else {
				used[i] = false;
			}
		}
		li cur = unmask();
		//li anticur = rev(cur);
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				if (res[i] & (1 << j)) {
					bool r = false;
					if (cur & (1 << j))
						r = true;
					if (used[i] != r) {
						res[i] ^= (1 << j);
					}
				}
			}
		}
		memcpy(pred, x, sizeof(x));
	}
	for (int i = 0; i < m; i++) {
		int r = -1;
		for (int j = 0; j < n; j++) {
			if ((res[i] & (1LL << j))) {
				if (r == -1)
					r = j;
				else {
					r = -1;
				}
			}
		}
		if (r == -1)
			printf("?");
		else {
			if (r < 10)
				printf("%d", r);
			else
				printf("%c", char('A' + r - 10));
		}
	}
	printf("\n");
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	while (true) {
		solve();
	}
}