#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define fi first
#define se second
#define mp make_pair
#define pb push_back

#define TASKNAME "coco"

typedef long long i64;
typedef long long li;
typedef long long lint;

using namespace std;

int n;
double pw;
double vw[100100], pf[100100], vf[100100], th[100100];
double a[100100];

#define INF 1000000000

inline double get(double d) {
	double res = pw * d;
	for (int i = 0; i < n; i++) {
		a[i] = d * vw[i];
		if (th[i] - a[i] > 0)
			res += (th[i] - a[i]) / vf[i] * pf[i];
	}
	return res;
}

void solve() {
	scanf("%d", &n);
	if (n == 0)
		exit(0);
	scanf("%lf", &pw);
	for (int i = 0; i < n; i++) {
		scanf("%lf%lf%lf%lf", &vw[i], &pf[i], &vf[i], &th[i]);
	}

	double l = 0, r = INF;
	for (int it = 0; it < 100; it++) {
		double d1 = l + (r - l) / 3;
		double d2 = l + 2.0 * (r - l) / 3.0;

		double r1 = get(d1), r2 = get(d2);
		if (r1 < r2) {
			r = d2;
		} else {
			l = d1;
		}
	}

	printf("%.5lf\n", get(l));
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	while (true) {
		solve();
	}
}