#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define fi first
#define se second
#define mp make_pair
#define pb push_back

#define TASKNAME "coco"

typedef long long i64;
typedef long long li;
typedef long long lint;

using namespace std;

const int it_count = 100;
const int maxn = 5e4 + 5;

double X[maxn];
double R[maxn];
int n;

const double eps = 1.0e-9;
const double inf = 1e9;

bool pos(double size)
{
	//double cur = size;
	//bool flag = true;
	double prev = -inf;
	double len = 0.0;
	forn(i, n)
	{
		double tmp = R[i] * R[i] - size * size * 0.25;
		if (tmp < eps)
		{
			prev = -inf;
			len = 0.0;
			continue;
		}
		double delta = sqrt(tmp);
		double s = X[i] - delta;
		double f = X[i] + delta;
		if (s - prev > eps)
			len = 2 * delta;
		else len += (f - prev);
		prev = f;
		if (len - size >= -eps)
			return true;
	}
	return false;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	while(true)
	{
		
		scanf("%d", &n);
		if (n == 0)
			break;
		forn(j, n)
			scanf("%lf%lf", &X[j], &R[j]);
		double start = 0.0;
		double finish = 2e5;
		//pos(12.4);
		forn(it, it_count)
		{
			double middle = (start + finish) / 2.0;
			if (pos(middle))
				start = middle;
			else finish = middle;
		}
		printf("%.10lf\n", start);
	}
}