#include <bits/stdc++.h>
using namespace std;
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define in(n) int n = nxt()
inline int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}
typedef long long ll;
typedef long double ld;
typedef pair<int, int> PII;
typedef pair<ll, ll> PLL;

struct pt {
    int x, y;
    pt(const int &x = 0, const int &y = 0) : x(x), y(y) {}
    pt(const pt &r) : x(r.x), y(r.y) {}
    pt & operator = (const pt &r) {
        if (this == &r) {
            return *this;
        }
        x = r.x;
        y = r.y;
        return *this;
    }

    pt operator + (const pt &r) const {
        return pt(x + r.x, y + r.y);
    }

    pt operator - (const pt &r) const {
        return pt(x - r.x, y - r.y);
    }

    friend int scal(const pt &l, const pt &r) {
        return l.x * r.x + l.y * r.y;
    }
    friend int vect(const pt &l, const pt &r) {
        return l.x * r.y - l.y * r.x;
    }
};

vector<vector<int> > g;


inline bool check(const pt &a, const pt &b, const pt &c, const pt &d) {
    if (vect(a - b, c - d) != 0) {
        return false;
    }
    if (vect(a - b, c - b) != 0) {
        return false;
    }
    int tb = 0;
    int ta = scal(a - b, a - b);
    int tc = scal(a - b, c - b);
    int td = scal(a - b, d - b);
    if (tc > td) {
        swap(tc, td);
    }
    int l = max(tb, tc);
    int r = min(ta, td);
    return l < r;
}

inline bool check(const vector<pt> &a, const vector<pt> &b) {
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (check(a[i], a[(i + 1) % n], b[j], b[(j + 1) % m])) {
                return true;
            }
        }
    }
    return false;
}

const int N = 40;
char used[N];
char part[N];
int q[N];
vector<int> order;

inline bool check2() {
    int n = g.size();
    memset(part, 255, n * sizeof(char));
    bool ok = true;
    for (int st = 0; st < n; ++st) {
        if (used[st]) {
            continue;
        }
        if (part[st] == -1) {
            int h = 0, t = 0;
            q[t++] = st;
            part[st] = 0;
            while (h<t) {
                int v = q[h++];
                for (int to : g[v]) {
                    if (used[to]) {
                        continue;
                    }
                    if (part[to] == -1)
                        part[to] = !part[v],  q[t++] = to;
                    else {
                        ok &= part[to] != part[v];
                        if (!ok) {
                            return false;
                        }
                    }
                }
            }
        }
    }
    return ok;
}

int IT = 600000;
int it;
bool rec(int u = 0, int cnt = 0) {
    int v = order[u];
    if (u == g.size()) {
        return check2();
    }
    if (cnt + 1 > g.size() / 3) {
        return check2();
    }

    ++it;
    if (it >= IT) {
        return false;
    }
    bool ok = true;
    for (int to : g[v]) {
        if (used[to]) {
            ok = false;
            break;
        }
    }

    if (rand() & 1) {
        if (ok) {
            used[v] = 1;
            if (rec(u + 1, cnt + 1)) {
                return true;
            }
            used[v] = 0;
        }

        if (rec(u + 1, cnt)) {
            return true;
        }
    } else {
        if (rec(u + 1, cnt)) {
            return true;
        }

        if (ok) {
            used[v] = 1;
            if (rec(u + 1, cnt + 1)) {
                return true;
            }
            used[v] = 0;
        }
    }
    return false;
}

bool check3() {
    order.clear();
    for (int i = 0; i < (int)g.size(); ++i) {
        order.push_back(i);
    }

    for (int i = 0; i < 10; ++i) {
        random_shuffle(all(order));
        it = 0;
        IT = min(65000.0, pow(1.5, g.size()) + 1000);
        memset(used, 0, g.size() * sizeof(char));
        //    sort(all(order), [&](int l, int r) {
        //        return g[l].size() < g[r].size();
        //    });
        if (rec()) {
            return true;
        }
    }
    return false;
}

void solve() {
    in(n);
    if (!n) {
        exit(0);
    }

    vector<pt> a[n];
    for (int i = 0; i < n; ++i) {
        in(m);
        a[i].resize(m);
        for (int j = 0; j < m; ++j) {
            a[i][j].x = nxt();
            a[i][j].y = nxt();
        }
    }
    //g.clear();
    g.assign(n, vector<int>());

    int edgesSize = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (check(a[i], a[j])) {
                g[i].pb(j);
                g[j].pb(i);
                ++edgesSize;
                //cout << "(" << i << "," << j << ")";
            }
        }
    }
    if (edgesSize == 0) {
        cout << "1\n";
        return;
    }
    memset(used, 0, sizeof(used));
    if (check2()) {
        cout << "2\n";
        return;
    }
    if (check3()) {
        cout << "3\n";
        return;
    }
    cout << "4\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

//    gen();
    int test = 0;
    while (1) {
        ++test;
        //cout << test << endl;
        solve();
    }
    return 0;
}
