#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define pa pair
#define ve vector

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 1010;

struct Input {
	int n, m, s, t;
	vector <pair<int, int> > e;	
	bool read () {
		if (scanf ("%d %d %d %d", &n, &m, &s, &t) != 4)
			return 0;
		if (n == 0)
			return 0;
		forn(i, m) {
			int u, v;
			scanf ("%d %d", &u, &v);
			u--, v--;
			e.pb(mp(u, v));	
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	pair<int, int> ans;
	
	void write () {
		cout << ans.fs << ' ' << ans.sc << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int inf = 100000;

struct Solution: Data {
	
	queue <int> q;
	int st, fn;
	int d[N];
	int p[N];
	vector <int> g[N], revg[N];
	bool use[N];
	
	struct item {
		int to, c, f, pr;
		item(){}
		item (int To, int C, int F, int Pr) {
			to = To;
			c = C;
			f = F;
			pr = Pr;
		}
		int get_c() {
			return c - f;
		}
	};
	
	vector <item> a[N];	
	
	void add (int u, int v, int c) {
		item k1(v, 1, 0, a[v].size());
		item k2(u, 0, 0, a[u].size());
		a[u].pb(k1);
		a[v].pb(k2);
	}
	
	bool bfs () {
		forn(i, n) {
			d[i] = inf;
		}
		d[st] = 0;
		while (!q.empty())
			q.pop();
		q.push(st);
		while (!q.empty()) {
			int k = q.front();
			q.pop();
			forn(i, a[k].size()) {
				int to = a[k][i].to;
				if (d[to] != inf)
					continue;
				if (a[k][i].get_c() <= 0)
					continue;
				d[to] = d[k] + 1;
				q.push(to);	
			}	
		}
		return d[fn] < inf;
	}
	
	int dfs (int v, int minn) {
		if (v == fn) {
			return minn;
		}
		use[v] = 1;
		for (int i = p[v]; i < int(a[v].size()); ++i) {
			int to = a[v][i].to;
			if (use[to] || a[v][i].get_c() <= 0 || d[to] != d[v] + 1)
				continue;
			int k = dfs(to, min(minn, a[v][i].get_c()));
			if (k > 0) {
				a[v][i].f += k;
				a[to][a[v][i].pr].f -= k;
				return k;
			}
			p[v]++;
		}
		return 0;
	}
	
	void build () {
		st = s - 1, fn = t - 1;
		forn(i, e.size()) {
			add(e[i].fs, e[i].sc, 1);
		}	
	}
	
	bool use1[N], use2[N];
	
	void dfs1 (int v) {
		use1[v] = 1;
		forn(i, g[v].size()) {
			int to = g[v][i];
			if (use1[to])
				continue;
			dfs1(to);
		}
	}
	
	void dfs2 (int v) {
		use2[v] = 1;
		forn(i, revg[v].size()) {
			int to = revg[v][i];
			if (use2[to])
				continue;
			dfs2(to);
		}
	}
	
	void solve () {
		build();
		while (bfs()) {
			memset(use, 0, sizeof(use));
			memset(p, 0, sizeof(p));
			while (dfs(st, inf)) {
				memset(use, 0, sizeof(use));
			}
		}
		forn(i, a[st].size()) {
			if (a[st][i].f > 0) {
				ans.fs += a[st][i].f;
			}
		}	
		forn(i, n) {
			forn(j, a[i].size()) {
				int to = a[i][j].to;
				if (a[i][j].get_c() > 0) {
					g[i].pb(to);
					revg[to].pb(i);
				}
			}
		}
		dfs1(st);
		dfs2(fn);
		debug(use1, use1 + n);
		debug(use2, use2 + n);
		forn(i, n) {
			forn(j, a[i].size()) {
				if (a[i][j].c <= 0)
					continue;
				int to = a[i][j].to;
				if (use2[i] && use1[to]) {
					ans.sc++;
				}
			}
		}
		if (ans.sc > 0)
			ans.fs++;
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#endif
	return 0;
}
