#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define pa pair
#define ve vector

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

struct Input {
	int n, x;
	ll dd;
	bool read () {
		if (!(cin >> n >> dd >> x)) {
			return 0;
		}
		if (n == 0 && dd == 0 && x == 0) {
			return 0;
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

const ll mod = 1000000007;

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int K = 40;
const int L = 14;
const int N = 1 << L;
const ld PI = 3.1415926535897932384626433832795L;

typedef complex<ld> cBase;

struct Solution: Data {
	
	vector <ll> d[K];
	
	cBase st[N + 1];
	int rBit[N];
	
	void precalc () {
		for (int i = 0; i <= N; ++i) {
			ld phi = 2 * PI / N * i;
			st[i] = cBase(cosl(phi), sinl(phi));
		}
		memset(rBit, 0, sizeof(rBit));
		
		for (int i = 0; i < N; ++i) {
			for (int j = 0; j < L; ++j) {
				if (i & (1 << j)) {
					rBit[i] |= 1 << (L - j - 1);
				}
			}		
		}
	}
	
	void fft (cBase a[], int n) {
		int e = 1, k = 0;
		while (e < n) {
			e *= 2;
			++k;
		}
		n = e;
		for (int i = 0; i < n; ++i) {
			int j = rBit[i] >> (L - k);

			if (i < j) {
				swap(a[i], a[j]);
			}
		}
		for (int k = 0; (1 << k) < n; ++k) {
			for (int i = 0; i < n; i += (2 << k)) {
				for (int j = 0; j < (1 << k); ++j) {
					cBase u = a[i + j];
					cBase & v = a[i + j + (1 << k)];
					cBase w = v * st[(j << (L - k - 1))];
					a[i + j] = u + w;
					a[i + j + (1 << k)] = u - w;
				}
			}
		}
	}
	
	
	void rev (cBase a[], int n) {
		reverse(a + 1, a + n);
		for (int i = 0; i < n; ++i) {
			a[i] /= n;
		}
	}
	
	cBase _a[2 * N], _b[2 * N];
	
	static const int Q = 33000;
		
	vector<ll> mult (vector<ll> a, vector<ll> b) {
		/*
		vector<ll> c(sz(a) + sz(b) - 1, 0);
		for (int i = 0; i < sz(a); ++i) {
			for (int j = 0; j < sz(b); ++j) {
				c[i + j] += (a[i] * b[j]) % mod;
			}
		}
		for (int i = 0; i < sz(c); ++i) {
			c[i] %= mod;
		}
		return c;
		*/
		
		int n = 1;
		while (n < (sz(a) + sz(b)) * 3) {
			n *= 2;
		}
		for (int i = 0; i < n; ++i) {
			_a[i] = _b[i] = 0;
		}
		
		forn (i, sz(a)) {
			_a[3 * i] = a[i] % Q;
			_a[3 * i + 1] = a[i] / Q;
		}
		forn (i, sz(b)) {
			_b[3 * i] = b[i] % Q;
		    _b[3 * i + 1] = b[i] / Q;
		}
		
		fft(_a, n);
		fft(_b, n);
		for (int i = 0; i < n; ++i) {
			_a[i] *= _b[i];
		}	
		fft(_a, n);
		rev(_a, n);
		
		vector<ll> res(sz(a) + sz(b) - 1);
		forn (i, sz(res)) {
			res[i] = 0;
			ford (j, 3) {
				res[i] = (Q * res[i] + ll(_a[3 * i + j].real() + 0.5)) % mod;
			}
		}
		
		return res;
	}
	
	void solve () {
		precalc();
		
		x = min(x, n);
		vector <ll> res(1, 1ll);
		d[0].resize(n);
		forn(i, x) {
			d[0][i] = 1;	
		}
		for (int i = 1; i < K; ++i) {
			d[i] = mult(d[i - 1], d[i - 1]);
	 		while ((int)d[i].size() > n + 1)
	 			d[i].pop_back();
	 	}
		forn(i, 40) {
			if (dd & (1ll << i)) {
				res = mult(res, d[i]);	
				while ((int)res.size() > n + 1) {
					res.pop_back();
				}
			}	
		}
		ans = 0;
		if ((int)res.size() > n) {
			ans = res[n];
		}	
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#endif
	return 0;
}
