#include <cassert>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define int64 long long
#define ldb long double
const double pi = acos(-1.0);
const int N = (int) 55555;
const int INF = (int) 1e6;
const double eps = 1e-10;
const int max_it = 100;
int x[N], n, r[N];

double sqr(double x) {
	return x * x;
}

bool check(double a) {
	vector< pair<double, int> > e;
	for (int i = 0; i < n; ++i)
		if (r[i] >= a / 2 + eps) {
			double sq = sqrt(sqr(r[i]) - sqr(a / 2));
			e.pb(mp(x[i] - sq, 1)), e.pb(mp(x[i] + sq, -1));
		}
	if (e.empty()) return false;
	sort(e.begin(), e.end());
	int sum = 0;
	double lb = 0;
	for (int i = 0; i < sz(e); ) {
		if (sum == 0) lb = e[i].fs;
		if ((sum > 0) && (e[i].fs - lb > a - eps)) return true;
		int j = i;
		while ((j < sz(e)) && (fabs(e[i].fs - e[j].fs) < eps)) sum += e[j++].sc;
		i = j;
	}
	return false;
}

int main() {
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));
	while ((scanf("%d", &n) == 1) && (n > 0)) {
		for (int i = 0; i < n; ++i)
			scanf("%d%d", &x[i], &r[i]);
		double l = 0, r = INF;
		for (int it = 0; it < max_it; ++it) {
			double q = (l + r) / 2;
			(check(q) ? l : r) = q;
		}
		printf("%.10lf\n", l);
	}
	return 0;
}