#include <cassert>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define int64 long long
#define ldb long double
const double pi = acos(-1.0);
const int size = 10 * 1000 + 10;
const int ssize = 200;

int ans[ssize][size];
int n, m, tot;
int p[size], t[size], k[size];
vector <int> vertex[size];
bool flag;
bool used[size];
vector <int> ts;
int cur[size];
int ncur[size];
int mdf[size];

void dfs(int v, int stv) {
	used[v] = true;
	for (int i = 0; i < (int) vertex[v].size(); i++) {
		if (vertex[v][i] == stv)
			flag = true;
		if (!used[vertex[v][i]])
			dfs(vertex[v][i], stv);
	}
}

void topsort(int v) {
	used[v] = true;
	for (int i = 0; i < (int) vertex[v].size(); i++)
		if (!used[vertex[v][i]])
			topsort(vertex[v][i]);

	ts.pb(v);
}

int main() {
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));

	while (true) {
		scanf("%d%d%d", &n, &m, &tot);

		if (n == 0 && m == 0 && tot == 0)
			break;

		for (int i = 0; i < n; i++)
			scanf("%d%d%d", &p[i], &t[i], &k[i]);
		int v, u;
		for (int i = 0; i < m; i++) {
			scanf("%d%d", &v, &u);
			v--, u--;

			vertex[v].pb(u);
		}

		for (int i = 0; i < n; i++) {
			flag = false;
			for (int j = 0; j < n; j++)
				used[j] = false;
			dfs(i, i);

			if (!flag)
				k[i] = 1;
		}

		for (int i = 0; i < n; i++)
			used[i] = false;
		for (int i = 0; i < n; i++)
			if (!used[i])
				topsort(i);

		for (int i = 0; i < n; i++) {
			for (int j = 0; j <= tot; j++)
				ans[i][j] = 0;
		}

		for (int i = 0; i < n; i++) {
			int v = ts[i];
			for (int j = 0; j <= tot; j++)
				cur[j] = 0;
			for (int j = 0; j < (int) vertex[v].size(); j++)
				for (int h = 0; h <= tot; h++)
					cur[h] = max(cur[h], ans[vertex[v][j]][h]);

			for (int j = 0; j <= tot; j++)
				ncur[j] = cur[j];
			for (int j = 0; j <= tot; j++)
				mdf[j] = ((tot - j + 1 + t[v] - 1) / t[v]) * p[v];
			for (int j = 0; j < t[v]; j++) {
				int p = j;
				deque <pair <int, int> > best;
				while (p <= tot) {
					while (!best.empty() && best.back().fs < cur[p] + mdf[p])
						best.pop_back();
					best.pb(mp(cur[p] + mdf[p], p));
					while (!best.empty() && best.front().sc < p - k[v] * t[v])
						best.pop_front();
					ncur[p] = max(ncur[p], best.front().fs - mdf[p]);

					p += t[v];
				}
			}

			for (int j = 0; j <= tot; j++)
				ans[v][j] = ncur[j];
		}

		int rans = 0;
		for (int i = 0; i < n; i++)
			for (int j = 0; j <= tot; j++)
				rans = max(rans, ans[i][j]);

		printf("%d\n", rans);

		for (int i = 0; i < n; i++)
			vertex[i].clear();
		ts.clear();
	}

	return 0;
}