#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 111;
const int T = int(1e4) + 100;

int sz;
bool used[N];
int lst[N], p[N], t[N], col[N], k[N];
vi g[N], rg[N], ver[N];
int d[N][T];
bool can[N][N];

void dfs1(int v) {
	used[v] = true;
	for (int i = 0; i < sz(g[v]); ++i) {
		if (!used[g[v][i]]) {
			dfs1(g[v][i]);
		}
	}
	lst[sz++] = v;
}

void dfs2(int v) {
	col[v] = sz;
	ver[sz].pb(v);
	for (int i = 0; i < sz(rg[v]); ++i) {
		if (col[rg[v][i]] == 0) {
			dfs2(rg[v][i]);
		}
	}
}

inline bool solve() {
	int n, m, T;
	scanf("%d %d %d", &n, &m, &T);
	if (n == 0 && m == 0 && T == 0) {
		return false;
	}
	for (int i = 0; i < n; ++i) {
		scanf("%d %d %d", &p[i], &t[i], &k[i]);
	}
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		rg[i].clear();
		used[i] = false;
		col[i] = 0;
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		scanf("%d %d", &a, &b);
		--a;
		--b;
		g[a].pb(b);
		rg[b].pb(a);
	}
	sz = 0;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs1(i);
		}
	}
	for (int i = 1; i <= n; ++i) {
		ver[i].clear();
	}
	sz = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (col[lst[i]] == 0) {
			++sz;
			dfs2(lst[i]);
		}
	}
	for (int i = 1; i <= sz; ++i) {
		for (int j = 1; j <= sz; ++j) {
			can[i][j] = false;
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < sz(g[i]); ++j) {
			if (col[i] != col[g[i][j]]) {
				can[col[g[i][j]]][col[i]] = true;
			}
		}
	}
	for (int i = 1; i <= sz; ++i) {
		for (int j = 0; j <= T; ++j) {
			d[i][j] = -inf;
		}
		d[i][0] = 0;
		for (int j = 1; j <= sz; ++j) {
			if (can[i][j]) {
				for (int z = 0; z <= T; ++z) {
					d[i][z] = max(d[i][z], d[j][z]);
				}
			}
		}
		for (int j = 0; j < sz(ver[i]); ++j) {
			int num = ver[i][j], cur = 1;
			if (sz(ver[i]) == 1) {
				bool fl = false;
				for (int z = 0; z < sz(g[num]); ++z) {
					if (g[num][z] == num) {
						fl = true;
						break;
					}
				}
				if (!fl) {
					k[num] = 1;
				}
			}
			while (k[num] >= cur) {
				for (int z = T; z >= cur * t[num]; --z) {
					d[i][z] = max(d[i][z], d[i][z - cur * t[num]] + cur * p[num]);
				}
				k[num] -= cur;
				cur *= 2;
			}
			if (k[num] > 0) {
				for (int z = T; z >= k[num] * t[num]; --z) {
					d[i][z] = max(d[i][z], d[i][z - k[num] * t[num]] + k[num] * p[num]);
				}
			}
		}
	}
	int ans = -inf;
	for (int i = 1; i <= sz; ++i) {
		for (int j = 0; j <= T; ++j) {
			ans = max(ans, d[i][j]);
		}
	}
	printf("%d\n", ans);
	return true;
}

int main() {
#ifdef LOCAL42
#define TASK "J"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	while (solve());
	return 0;
}
