#include <algorithm>
#include <iostream>
#include <sstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iterator>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cctype>

using namespace std;

#define FOR(i, a, b) for (int i = (a); i < (b); ++i)
#define ROF(i, a, b) for (int i = (b) - 1; i >= (a); --i)

typedef pair <int, int> pii;
typedef long long LL;
typedef LL ll;

const int INF = 1000000000;
const LL LINF = (LL) INF * (LL) INF;

LL mask(string const &s) {
  LL base = 1, ans = 0;
  for (int i = 0; i != s.length(); ++i) {
    if (s[i] == '1') {
      ans += base;
    }
    base <<= 1LL;
  }
  return ans;
}

int main() {
  ios_base::sync_with_stdio(false);

  while (true) {

  int n, m, q;
  cin >> n >> m >> q;

  if (!n && !m && !q) { return 0; }

  vector <LL> answer(m, (1LL << (LL)(n)) - 1LL);
  string current(m, '0'), readMask, r;

  for (int i = 0; i != q; ++i) {

    cin >> readMask >> r;
    LL cm = mask(readMask);

    for (int i = 0; i != m; ++i) {
      answer[i] &= (current[i] != r[i] ? cm : ~cm);
    }

    current = r;
  }
        
  for (int i = 0; i != m; ++i) {
    int pos = 0;
    while (!(answer[i] & (1LL << (LL)pos))) ++pos;
    if (answer[i] >> (LL) (pos + 1)) {
      cout << '?';
    }
    else if (pos < 10) {
      cout << pos;
    }
    else {
      cout << (char)('A' + (pos - 10));
    }  
  }

  cout << '\n'; 

  }
}