#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <algorithm>
using namespace std;

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(a) a.begin(), a.end()

#define mp make_pair
#define pb push_back

#define fs first
#define sc second

const long long mpow = 100051;

char lamps[1000][1000];
char conts[1000][36];
string ans;
long long chash[36], lhash[1000];
long long pows[1000];

char get(int j)
{
    if(j <= 9)
        return '0' + j;
    return 'A' + j - 10;
}

int main()
{
    ios_base::sync_with_stdio(0);
    pows[0] = 1;
    for(int i = 1; i < 1000; ++i)
        pows[i] = pows[i - 1] * mpow;
    while(1)
    {
        int n, m, q;
        cin >> n >> m >> q;
        if(n == 0 && m == 0 && q == 0)
            break;
        ans.resize(m);
        forn(i, m)
            ans[i] = '?';
        forn(i, q)
        {
            forn(j, n)
                conts[i][j] = 0;
            forn(j, m)
                lamps[i][j] = 0;
        }
        forn(i, n)
            chash[i] = 0;
        forn(i, m)
            lhash[i] = 0;
        forn(i, q)
        {
            string s1, s2;
            cin >> s1 >> s2;
            forn(j, n)
            {
                conts[i][j] = s1[j] - '0';
                if(i > 0)
                    conts[i][j] ^= conts[i - 1][j];
                chash[j] += conts[i][j] * pows[i];
            }
            forn(j, m)
            {
                lamps[i][j] = s2[j] - '0';
                lhash[j] += lamps[i][j] * pows[i];
            }
        }
        /*forn(i, n)
            cout << chash[i] << " ";
        cout << endl;
        forn(i, m)
            cout << lhash[i] << " ";
        cout << endl;*/
        forn(i, m)
        {
            char ok = 0;
            forn(j, n)
            {
                if(chash[j] == lhash[i])
                {
                    ans[i] = get(j);
                    ++ok;
                }
                if(ok > 1)
                {
                    ans[i] = '?';
                    break;
                }
            }
        }
        cout << ans << '\n';
    }
    return 0;
}
