#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <algorithm>
using namespace std;

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(a) a.begin(), a.end()

#define mp make_pair
#define pb push_back

#define fs first
#define sc second

vector <pair<int, int> > cl;

bool between(double a, double b, double c)
{
    return b >= a && b <= c;
}

bool intersect(pair<double, double> &a, pair<double, double> &b)
{
    return between(b.fs, a.sc, b.sc);
}

pair<double, double> merge(pair<double, double> a, pair<double, double> b)
{
    return mp(a.fs, b.sc);
}

double get_ans(int lpos, int rpos, double h)
{
    vector <pair<double, double> > vc;
    for(int i = lpos; i <= rpos; ++i)
    {
        if(cl[i].sc >= h)
        {
            double x = sqrt(1.0 * cl[i].sc * cl[i].sc - h * h);
            vc.pb(mp(cl[i].fs - x, cl[i].fs + x));
        }
    }
    if(vc.size() == 0)
        return -1;
    int pos = 0;
    double ans = -1;
    while(pos < vc.size())
    {
        pair<double, double> cans = vc[pos];
        while(pos + 1 < vc.size() && intersect(cans, vc[pos + 1]))
        {
            cans = merge(cans, vc[pos + 1]);
            ++pos;
        }
        ans = max(ans, cans.sc - cans.fs);
        ++pos;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.precision(7);
    while(1)
    {
        int n;
        cin >> n;
        if(n == 0)
            break;
        cl.resize(n);
        forn(i, n)
            cin >> cl[i].fs >> cl[i].sc;
        double ans = 0;
        forn(i, n)
            ans = max(ans, sqrt(2) * cl[i].sc);
        forn(i, n - 1)
        {
            double l = cl[i + 1].fs - cl[i].fs;
            double x1, x2;
            x2 = (l * l - 1.0 * cl[i].sc * cl[i].sc + 1.0 * cl[i + 1].sc * cl[i + 1].sc) / 2 / l;
            x1 = l - x2;
            double left = 0, right = sqrt(1.0 * cl[i].sc * cl[i].sc - x1 * x1);
            forn(j, 15)
            {
                double m = (left + right) / 2;
                if(get_ans(i, i + 1, m) >= 2 * m)
                    left = m;
                else
                    right = m;
            }
            ans = max(ans, left * 2);
        }
        cout << fixed << ans << endl;
    }
    return 0;
}