#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <algorithm>
using namespace std;

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(a) a.begin(), a.end()

#define mp make_pair
#define pb push_back

#define fs first
#define sc second

const double eps = 1e-8;

vector <pair<int, int> > cl;

bool between(double a, double b, double c)
{
    return b >= a - eps && b <= c + eps;
}

bool intersect(pair<double, double> &a, pair<double, double> &b)
{
    return between(b.fs, a.sc, b.sc) || between(a.fs, b.sc, a.sc);
}

pair<double, double> merge(pair<double, double> a, pair<double, double> b)
{
    return mp(min(a.fs, b.fs), max(a.sc, b.sc));
}

double get_ans(double h)
{
    vector <pair<double, double> > vc;
    forn(i, cl.size())
    {
        if(cl[i].sc >= h - eps)
        {
            double x = sqrt(1.0 * cl[i].sc * cl[i].sc - h * h);
            vc.pb(mp(cl[i].fs - x, cl[i].fs + x));
        }
    }
    if(vc.size() == 0)
        return 0;
    int pos = 0;
    double ans = 0;
    while(pos < vc.size())
    {
        pair<double, double> cans = vc[pos];
        while(pos + 1 < vc.size() && intersect(cans, vc[pos + 1]))
        {
            cans = merge(cans, vc[pos + 1]);
            ++pos;
        }
        ans = max(ans, cans.sc - cans.fs);
        ++pos;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.precision(7);
    while(1)
    {
        int n;
        cin >> n;
        if(n == 0)
            break;
        cl.resize(n);
        forn(i, n)
            cin >> cl[i].fs >> cl[i].sc;
        double ans = 0;
        forn(i, n)
            ans = max(ans, sqrt(2) * cl[i].sc);
        double left = 0, right = 1000000;
        forn(j, 100)
        {
            double m = (left + right) / 2;
            if(get_ans(m) >= 2 * m)
                left = m;
            else
                right = m;
        }
        cout << fixed << 2 * left << endl;
    }
    return 0;
}
