#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <algorithm>
#include <cassert>
using namespace std;

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(a) a.begin(), a.end()

#define mp make_pair
#define pb push_back

#define fs first
#define sc second

const int X = 2010;
long long MOD = 1e9 + 7;

int dp[X][X], pr[X][X];

pair<long long, long long> gcd(long long a, long long b) {
    if(!b)
        return make_pair(1, 0);
    pair<long long, long long> p = gcd(b, a % b);
    return make_pair(p.second, (p.first - (a / b) * p.second));
}

long long inv(long long a) {
    return (gcd(a, MOD).first + MOD) % MOD;
}

int safe(int a)
{
    if(a >= MOD) return a - MOD;
    return a;
}

int get_ans(int l, int r, int num)
{
    if(l <= 0) return pr[num][r];
    int a = pr[num][r] - pr[num][l - 1] + MOD;
    if(a >= MOD) return a - MOD;
    return a;
}

int main()
{
    ios_base::sync_with_stdio(0);
    while(true)
    {
        long long d, ans = 0, now = 1;
        int n, x;
        cin >> n >> d >> x;
        if(n == 0 && d == 0 && x == 0) break;
        if(x == 1)
        {
            cout << "0\n";
            continue;
        }
        for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                dp[i][j] = 0;
                pr[i][j] = 0;
            }
        }
        for(int i = 1; i < min(x, n + 1); i++)
        {
            dp[1][i] = 1;
        }
        for(int i = 1; i <= n; i++)
            pr[1][i] = safe(pr[1][i - 1] + dp[1][i]);
        for(int i = 2; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                dp[i][j] = get_ans(j - x + 1, j - 1, i - 1);
                pr[i][j] = safe(dp[i][j] + pr[i][j - 1]);
            }

        }

         /*for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                cout << dp[i][j] << ' ';
            }
            cout << '\n';

        }*/

        for(long long i = 1; i <= min((long long)n, d); i++)
        {
            now = (((d - i + 1) % MOD) * now % MOD * inv(i)) % MOD;
            ans = (ans + (now * dp[i][n]) % MOD) % MOD;
        }
        cout << ans << '\n';
    }
    return 0;
}
