#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <utility>
#include <vector>
using namespace std;

#define foreach(u, o) \
    for (typeof((o).begin()) u = (o).begin(); u != (o).end(); ++u)
const int INF = 2147483647;
const double EPS = 1e-9;
const double pi = acos(-1);
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vi> vvi;
typedef vector<vii> vvii;
template <class T> T mod(T a, T b) { return (a % b + b) % b; }
template <class T> int size(const T &x) { return x.size(); }

int main()
{
    int N, M, Q;
    while(cin >> N >> M >> Q && (N != 0 || M != 0 || Q != 0)){
        vector<string> B(Q);
        vector<string> S(Q);
        vvi opt(M);

        for(int i = 0; i < Q; ++i){
            cin >> S[i] >> B[i];
        }

        //for(int i = 0; i < Q; ++i){
            //cout << S[i] << " " << B[i] << endl;
        //}

        //cout << N << " " << M << endl;
        for(int i = 0; i < M; ++i){ // lights
            for(int j = 0; j < N; ++j){ // possible switches
                bool possible = true;
                if(Q){
                    //cout << S[0][j] << " " << B[0][i] << endl;
                    if(S[0][j] != B[0][i]){
                        possible = false;
                    }
                }
                //printf("Light %d: switch %d:\n", i, j);
                for(int k = 1; k < Q && possible; ++k){ // actions

                    //printf("%d: %c %c\n", S[k][j], B[k][i], B[k-1][i]);
                    if((S[k][j] == '1' && (B[k][i] == B[k-1][i]) ) ||
                       (S[k][j] == '0' && (B[k][i] != B[k-1][i]) )){
                        possible = false;
                        //break;
                    }
                }
                if(possible){
                    opt[i].push_back(j);
                }
            }
        }
        for(int i = 0; i < M; ++i){
            if(opt[i].size() == 1){
                if(opt[i][0] > 9){
                    cout << (char)(opt[i][0]-10 + 'A');
                } else {
                    cout << opt[i][0];
                }
            } else if(opt[i].size() == 0){
                cout << '!';
            } else {
                cout << '?';
            }
        }
        cout << endl;
    }
}
