#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <string>
using namespace std;

typedef long long ll;

//double vw[61000], pf[61000], vf[61000], th[61000];
double *vw, *pf, *vf, *th;
int N;
double pw;

double EPS = 1e-4;

double cost(double W)
{
    double tot_cost = 0.0;
    for(int i = 0; i < N; ++i){
        tot_cost += max((th[i] - W * vw[i])/vf[i] , 0.0) * pf[i];
    }
    return tot_cost;
}


int main() {


    while( cin >> N >> pw && N != 0 ) {

        vw = new double[N];
        pf = new double[N];
        vf = new double[N];
        th = new double[N];


        for(int i = 0; i < N; ++i){
            cin >> vw[i] >> pf[i] >> vf[i] >> th[i];
            // cout << vw[i] << " " << pf[i]  << " " << vf[i]  << " " << th[i] << endl;
        }


        //double min_cost = INFINITY;
        //double hi = 110.0;
        double hi = 1e9;

        //vector<double> Ws(N);

        //for(int i = 0; i < N; ++i){
        //    if (abs(vw[i]) < 1e-9 || vw[i] < 0.0)
        //        Ws[i] = 0.0;
        //    else
        //        Ws[i] = th[i] / vw[i];

        //    //hi = max(hi, W);
        //    //double tot_cost = W*pw + cost(W);
        //    //min_cost = min(min_cost, tot_cost);
        //}

        //cout << hi << " = W" << endl;
        //double lo = 0.0;


        //sort(Ws.begin(), Ws.end());

        //for (int i = 0; i < Ws.size(); i++) {
            //cout << Ws[i] << " " << cost(Ws[i]) + Ws[i] * pw << endl;


        //}

        //int lo = 0,
        //    hi = N - 1;

        double lo = 0.0;

        while (true) {

            double c1 = lo*pw + cost(lo);
            double c2 = hi*pw + cost(hi);
            if(abs(c1 - c2) < 1e-7){
                break;
            }

            //int m1 = lo + 1 * (hi - lo) / 3;
            //int m2 = lo + 2 * (hi - lo) / 3;

            double m1 = lo + 1 * (hi - lo) / 3;
            double m2 = lo + 2 * (hi - lo) / 3;

            /*
            if (m1 == lo) {
                if (m1 == m2) {
                    m1++;
                    m2++;
                } else {
                    m1++;
                }
            }

            if (m2 == hi) {
                if (m1 == m2) {
                    m1--;
                    m2--;
                } else {

                }
            }
            */


            if (m1*pw + cost(m1) < m2*pw + cost(m2)) {
                hi = m2;
            } else {
                lo = m1;
            }
        }

        //double mx = INFINITY;
        //for (int i = lo; i <= hi; i++) {
        //    double W = Ws[i];
        //    mx = min(mx, W * pw + cost(W));
        //}


        //printf("%0.10lf\n", min(Ws[hi] * pw + cost(Ws[hi]), Ws[lo] * pw + cost(Ws[lo])));
        printf("%0.10lf\n", lo*pw + cost(lo));
        //cout << hi*pw + cost(hi) << endl;
    }

    return 0;
}
