#include <iostream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <ctime>
#include <cassert>
#include <string>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <memory.h>

#define pb push_back
#define mp make_pair
#define fr first
#define sc second

using namespace std;

const int N = 2e5 + 10;
const int INF = 1e6;
const int T = 50;
const double eps9 = 1e-9;

struct event {
	double t;
	int type;
	event() { }
	event(double t, int type): t(t), type(type) { }
};

int x[N];
int r[N];
int n;
int cur;
pair < double, double > b[N];
vector < event > e1;
vector < event > e2;
event e[N];


bool cmp(event a, event b) {
	return a.t < b.t;
}

int del(pair < double, double > * b, int cur) {
	int cur1 = 0;
	for (int i = 0; i < cur; i++) {
		for (; cur1 > 0 && b[i].fr <= b[cur1 - 1].fr ; cur1--);
		b[cur1++] = b[i];
	}
	return cur1;
}

void rev(pair < double, double > * b, int cur) {
	for (int i = 0; i < cur; i++) {
		b[i].fr *= -1;
		b[i].sc *= -1;
		swap(b[i].fr, b[i].sc);
	}
	reverse(b, b + cur);
}

bool cmpE(event a, event b) {
	return a.t < b.t;
}

bool check(double X) {
	cur = 0;
	for (int i = 0; i < n; i++) {
		if (r[i]  <= X + eps9) continue;
		double d = sqrt(r[i] * 1ll * r[i] - X * X);
		b[cur++] = mp(x[i] - d, x[i] + d);
	}
	//cerr << "cur: " << cur << endl;
	cur = del(b, cur);	
	//cerr << "cur: " << cur << endl;
	rev(b, cur);
	cur = del(b, cur);
	//cerr << "cur: " << cur << endl;
	rev(b, cur);

	e1.clear();
	e2.clear();
	for (int i = 0; i < cur; i++) {
		e1.pb(event(b[i].fr, 1));
		e2.pb(event(b[i].sc, -1));
	}
	merge(e1.begin(), e1.end(), e2.begin(), e2.end(), e, cmpE);
	cur *= 2;
	//sort(b, b + cur, cmp);
	//for (int

	int cnt = 0;
	double last = 0;
	bool flag = 0;
	for (int i = 0; i < cur; i++) {
		auto x = e[i];
		if (x.type == 1) {
			cnt++;
			if (cnt == 1)
				last = x.t;
		}
		if (x.type == -1) {
			cnt--;
			if (cnt == 0 && x.t - last >= X * 2)
				flag = 1;
		}
	}
	assert(cnt == 0);
	return flag;
}


int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
	while (true) {
		scanf("%d", &n);
		if (n == 0) return 0;
		for (int i = 0; i < n; i++)
			scanf("%d%d", &x[i], &r[i]);
		double l = 0;
		double r = INF;
		//check(4);
		//return 0;
		for (int t = 0; t < T; t++) {
			if (check((l + r) / 2))
				l = (l + r) / 2;
			else
				r = (l + r) / 2;
		}
		printf("%.15lf\n", l * 2);
		//cerr << clock() * 1.0 / CLOCKS_PER_SEC << endl;
	}
	cerr << endl;
	cerr << clock() * 1.0 / CLOCKS_PER_SEC << endl;
	return 0;
}
