#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

LL gcd(LL a, LL b)
{
    return a == 0 ? b : gcd(b % a, a);
}

struct frac
{
    LL x, y;
    frac() {}
    frac(LL x, LL y): x(x), y(y) {}

    void norm()
    {
        LL g = gcd(abs(x), abs(y));
        x /= g;
        y /= g;
        if (y < 0)
            x *= -1, y *= -1;
    }

    friend frac operator +(const frac &a, const frac &b)
    {
        LL d = a.y * b.y;
        LL f = a.x * b.y + a.y * b.x;
        LL g = gcd(abs(f), abs(d));
        frac res =  frac(f / g, d / g);
        res.norm();
        return res;
    }

    friend frac operator -(const frac &a, const frac &b)
    {
        LL d = a.y * b.y;
        LL f = a.x * b.y - a.y * b.x;
        LL g = gcd(abs(f), abs(d));
        frac res =  frac(f / g, d / g);
        res.norm();
        return res;
    }

    friend frac operator *(const frac &a, int v)
    {
        frac res = frac(a.x * v, a.y);
        res.norm();
        return res;
    }
};

void solve()
{
    string s;
    while (cin >> s)
    {
        if (s == "#")
            return;
        int n = s.size();
        stack<int> sp;
        for (int i = 0; i < n; i++)
        {
            if (s[i] == 'w')
            {
                sp.push(1);
                i += 3;
            }
            else
            {
                sp.push(-1);
                i += 4;
            }

        }

        frac ans(-1, 1);
        int cnt = 1;
        while(sp.size())
        {
            int v = sp.top();
            sp.pop();
            if (cnt == 1)
            {
                ans = v == 1? frac(90, 1) : frac(0, 1);
            }
            else
            {
                ans = ans + frac(90, 1 << (cnt - 1)) * v;
            }
            cnt++;
        }
        if (ans.y == 1)
            cout << ans.x << endl;
        else
            cout << ans.x << "/" << ans.y << endl;
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif