#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

struct st
{
    LD W;
    int type, id;
    st() {}
    st(LD W, int type, int id) : W(W), type(type), id(id) {}
    friend bool operator< (const st & a, const st &b)
    {
        return mp(a.W, mp(a.type, a.id)) < mp(b.W, mp(b.type, b.id));
    }
};

bool solve()
{
    int n;
    cin >> n;
    if (n == 0)
        return false;
    int pw;
    cin >> pw;
    vector <int> vw(n), pf(n), vf(n), th(n);

    for (int i = 0; i < n; i++)
        cin >> vw[i] >> pf[i] >> vf[i] >> th[i];

    vector <st> ev;
    LD ans = 0;
    LD sum1 = 0, sum2 = 0;   
    LD ans1 = 0;
    for (int i = 0; i < n; i++)
    {
        if (vw[i] == 0)
            ans += max(LD(0), (LD(th[i]) / vf[i]) * pf[i]);
        else
        {
            if (vw[i] > 0)
            {  
                LD w = LD(th[i]) / vw[i];
                if (w < 0)
                    continue;
                ev.pb(st(w, 0, i));
                sum1 += LD(vw[i]) * pf[i] / vf[i];
            }
            else
            {
                LD w = LD(th[i]) / vw[i];
                if (w < 0)
                    sum2 += LD(vw[i]) * pf[i] / vf[i];
                else
                    ev.pb(st(w, 1, i));


            }
            ans1 += max(LD(0), (LD(th[i]) / vf[i]) * pf[i]);
        }
    }
    sort(ev.begin(), ev.end());

 
    LD lastW = 0;
    LD res = ans1;
    for (int i = 0; i < ev.size(); i++)
    {
        LD dW = ev[i].W - lastW;
        res += (-sum1 - sum2 + pw) * dW;
        ans1 = min(ans1, res);
        int id = ev[i].id;
        if (ev[i].type == 0)
            sum1 -= LD(vw[id]) * pf[id] / vf[id];
        else
            sum2 += LD(vw[id]) * pf[id] / vf[id];
        lastW = ev[i].W;
    }
    cout.setf(ios::fixed);
    cout.precision(9);
    cout << ans + ans1 << endl;
    return true;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    while(solve());
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif