#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

namespace solution
{

const int maxn = 50 * 1000 + 100;
int n;
int x[maxn], r[maxn];

typedef pair<LD, char> event_t;

event_t evs[2 * maxn];
int k = 0;

bool check(LD h)
{
    k = 0;

    forn(i, n)
        if (r[i] > h)
        {
            LD wd = sqrt(LD(r[i]) * r[i] - h * h);
            evs[k++] = event_t(LD(x[i]) - wd, 0);
            evs[k++] = event_t(LD(x[i]) + wd, 1);
        }
    
    sort(evs, evs + k);

    stack<LD> st;
    forn(i, k)
    {
        if (evs[i].Y == 0)
            st.push(evs[i].X);
        else
        {
            if (st.size() == 1)
            {
                LD l = st.top();
                LD r = evs[i].X;
                LD w = r - l;
                if (w >= 2 * h)
                    return true;
            }
            st.pop();
        }
    }

    return false;
}

bool solve()
{
    scanf("%d", &n);
    if (n == 0)
        return false;

    forn(i, n)
        scanf("%d %d", &x[i], &r[i]);

    LD l = 0, r = 1e5 + 100;
    forn(it, 40)
    {
        LD m = (l + r) / 2;
        if (check(m))
            l = m;
        else
            r = m;
    }

    LD res = 2 * l;
    printf("%.10lf\n", res);

    return true;
}

}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    while (solution::solve());
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif