#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"
#define MAXN 2000
#define MOD 1000000007

LL c[MAXN + 2];
int dp[MAXN + 1][MAXN + 1];
int p[MAXN + 1][MAXN + 1];
int n, x, res;
LL d;

void init(){
    c[1] = d % MOD;
    for (int i = 2; i <= MAXN; i++){
        c[i] = c[i - 1];
        while (c[i] % i != 0) c[i] += MOD;
        c[i] /= i;
        c[i] %= MOD;
        c[i] = (c[i] * ((d - i + 1) % MOD)) % MOD;
    }
    memset(dp, 0, sizeof(dp));
    memset(p, 0, sizeof(p));
    res = 0;
}

void readin(){
    cin >> n >> d >> x;
}

void process(){
    dp[0][0] = 1;
    p[0][0] = 1;
    for (int j = 1; j <= n; j++)
        p[0][j] = 1;
    for (int i = 1; i <= n; i++){
        for (int j = i; j <= n; j++){
            dp[i][j] = p[i - 1][j - 1];
            if (j - x >= 0){
                dp[i][j] = (dp[i][j] + MOD - p[i - 1][j - x]) % MOD;
            }
            /*
            for (int k = 1; k < min(j + 1, x); k++)
                dp[i][j] = (dp[i][j] + dp[i - 1][j - k]) % MOD;*/
                
        }
        p[i][0] = 0;
        for (int j = 1; j <= n; j++){
            p[i][j] = (p[i][j - 1] + dp[i][j]) % MOD;
        }
        res = (res + c[i] * dp[i][n]) % MOD;
    }
}

void writeout(){
    cout << res << endl;
}

void solve()
{
    while (true){
        readin();
        if (n == 0) return;
        init();
        process();
        writeout();
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif