    import java.io.ByteArrayInputStream;
    import java.io.IOException;
    import java.io.InputStream;
    import java.io.PrintWriter;
    import java.util.ArrayDeque;
    import java.util.ArrayList;
    import java.util.Arrays;
    import java.util.InputMismatchException;
    import java.util.List;
    import java.util.Queue;
     
    public class f {
    static InputStream is;
    static PrintWriter out;
    static String INPUT = "";
    static void solve()
    {
    while(true){
    int n = ni(), m = ni(), s = ni(), t = ni();
    if(n+m+s+t==0)break;
    s--;
    t--;
    List<Edge> es = new ArrayList<Edge>();
    for(int i = 0;i < m;i++){
    es.add(new Edge(ni()-1, ni()-1, 1));
    }
    Edge[][] g = compileWD(n, es);
    long f = maximumFlowDinicNoRec(g, s, t);
    boolean[] fromSrc = new boolean[n];
    boolean[] fromSink = new boolean[n];
    Queue<Integer> q = new ArrayDeque<Integer>();
    q.add(s);
    fromSrc[s] = true;
    while(!q.isEmpty()){
    int cur = q.poll();
    for(Edge e : g[cur]){
    if(e.flow < e.capacity && !fromSrc[e.to]){
    fromSrc[e.to] = true;
    q.add(e.to);
    }
    }
    }
    q.add(t);
    fromSink[t] = true;
    while(!q.isEmpty()){
    int cur = q.poll();
    for(Edge e : g[cur]){
    if(e.complement.flow < e.complement.capacity && !fromSink[e.to]){
    fromSink[e.to] = true;
    q.add(e.to);
    }
    }
    }
    int ct = 0;
    for(int i = 0;i < m;i++){
    Edge e = es.get(i);
    if(e.flow < e.capacity && fromSrc[e.to] && fromSink[e.from]){
    ct++;
    }
    }
    out.println(f+(ct > 0 ? 1 : 0) + " " + ct);
    }
    }
    public static class DJSet {
    public int[] upper;
     
    public DJSet(int n) {
    upper = new int[n];
    Arrays.fill(upper, -1);
    }
     
    public int root(int x) {
    return upper[x] < 0 ? x : (upper[x] = root(upper[x]));
    }
     
    public boolean equiv(int x, int y) {
    return root(x) == root(y);
    }
     
    public boolean union(int x, int y) {
    x = root(x);
    y = root(y);
    if (x != y) {
    if (upper[y] < upper[x]) {
    int d = x;
    x = y;
    y = d;
    }
    upper[x] += upper[y];
    upper[y] = x;
    }
    return x == y;
    }
     
    public int count() {
    int ct = 0;
    for (int u : upper)
    if (u < 0)
    ct++;
    return ct;
    }
    }
    public static class Edge
    {
    public int from, to;
    public int capacity;
    public int flow;
    public Edge complement;
    // public int iniflow;
    public Edge(int from, int to, int capacity) {
    this.from = from;
    this.to = to;
    this.capacity = capacity;
    }
    }
    public static Edge[][] compileWD(int n, List<Edge> edges)
    {
    Edge[][] g = new Edge[n][];
    // cloning
    for(int i = edges.size()-1;i >= 0;i--){
    Edge origin = edges.get(i);
    Edge clone = new Edge(origin.to, origin.from, origin.capacity);
    clone.flow = origin.capacity;
    clone.complement = origin;
    origin.complement = clone;
    edges.add(clone);
    }
    int[] p = new int[n];
    for(Edge e : edges)p[e.from]++;
    for(int i = 0;i < n;i++)g[i] = new Edge[p[i]];
    for(Edge e : edges)g[e.from][--p[e.from]] = e;
    return g;
    }
    public static Edge[][] compileWU(int n, List<Edge> edges)
    {
    Edge[][] g = new Edge[n][];
    // cloning
    for(int i = edges.size()-1;i >= 0;i--){
    Edge origin = edges.get(i);
    Edge clone = new Edge(origin.to, origin.from, origin.capacity*2);
    origin.flow = origin.capacity;
    clone.flow = origin.capacity;
    clone.complement = origin;
    origin.complement = clone;
    origin.capacity *= 2;
    edges.add(clone);
    }
    int[] p = new int[n];
    for(Edge e : edges)p[e.from]++;
    for(int i = 0;i < n;i++)g[i] = new Edge[p[i]];
    for(Edge e : edges)g[e.from][--p[e.from]] = e;
    return g;
    }	
    public static long maximumFlowDinic(Edge[][] g, int source, int sink)
    {
    int n = g.length;
    int[] d = new int[n];
    int[] q = new int[n];
    long ret = 0;
    while(true){
    Arrays.fill(d, -1);
    q[0] = source;
    int r = 1;
    d[source] = 0;
    for(int v = 0;v < r;v++){
    int cur = q[v];
    for(Edge ne : g[cur]){
    if(d[ne.to] == -1 && ne.capacity - ne.flow > 0) {
    q[r++] = ne.to;
    d[ne.to] = d[cur] + 1;
    }
    }
    }
    if(d[sink] == -1)break;
    int[] sp = new int[n];
    for(int i = 0;i < n;i++)sp[i] = g[i].length - 1;
    ret += dfsDinic(d, g, sp, source, sink, Long.MAX_VALUE);
    }
    return ret;
    }
    private static long dfsDinic(int[] d, Edge[][] g, int[] sp, int cur, int sink, long min)
    {
    if(cur == sink)return min;
    long left = min;
    for(int i = sp[cur];i >= 0;i--){
    Edge ne = g[cur][i];
    if(d[ne.to] == d[cur]+1 && ne.capacity - ne.flow > 0){
    long fl = dfsDinic(d, g, sp, ne.to, sink, Math.min(left, ne.capacity - ne.flow));
    if(fl > 0){
    left -= fl;
    ne.flow += fl;
    ne.complement.flow -= fl;
    if(left == 0){
    sp[cur] = i;
    return min;
    }
    }
    }
    }
    sp[cur] = -1;
    return min-left;
    }
    public static long maximumFlowDinicNoRec(Edge[][] g, int source, int sink)
    {
    int n = g.length;
    int[] d = new int[n]; // distance
    int[] q = new int[n]; // queue for BFS
    long ret = 0;
    int[] stack = new int[n];
    long[] lefts = new long[n]; // left to flow
    long[] parflow = new long[n];
    int[] probe = new int[n]; // search pointer
    while(true){
    // BFS
    Arrays.fill(d, -1);
    q[0] = source;
    int r = 1;
    d[source] = 0;
    for(int v = 0;v < r;v++){
    int cur = q[v];
    for(Edge ne : g[cur]){
    if(d[ne.to] == -1 && ne.capacity - ne.flow > 0) {
    q[r++] = ne.to;
    d[ne.to] = d[cur] + 1;
    }
    }
    }
    if(d[sink] == -1)break;
    // DFS
    for(int i = 0;i < n;i++)probe[i] = g[i].length;
    int sp = 0;
    stack[sp] = source;
    lefts[sp] = Long.MAX_VALUE;
    parflow[sp] = 0;
    sp++;
    long delta = 0;
    boolean down = true;
    while(sp > 0){
    int cur = stack[sp-1];
    long fl = lefts[sp-1];
    if(cur == sink){
    delta += fl;
    parflow[sp-1] = fl;
    sp--;
    down = false;
    continue;
    }
    if(!down && parflow[sp] > 0){
    lefts[sp-1] -= parflow[sp];
    fl = lefts[sp-1];
    Edge ne = g[cur][probe[cur]];
    ne.flow += parflow[sp];
    ne.complement.flow -= parflow[sp];
    parflow[sp-1] += parflow[sp];
    }
    if(fl > 0 && probe[cur] > 0){
    down = true;
    Edge ne = g[cur][--probe[cur]];
    if(d[ne.to] == d[cur]+1 && ne.capacity - ne.flow > 0){
    lefts[sp] = Math.min(lefts[sp-1], ne.capacity - ne.flow);
    stack[sp] = ne.to;
    parflow[sp] = 0;
    sp++;
    }
    }else{
    down = false;
    sp--;
    }
    }
    ret += delta;
    }
    return ret;
    }
    public static boolean canAugment(Edge[][] g, int pfrom, int pto, int source, int sink)
    {
    int n = g.length;
    boolean[] ved = new boolean[n];
    return dfs(g, pfrom, pto, source, sink, ved);
    }
    static boolean dfs(Edge[][] g, int pfrom, int pto, int cur, int sink, boolean[] ved)
    {
    if(ved[cur])return false;
    if(cur == sink)return true;
    ved[cur] = true;
    for(Edge e : g[cur]){
    if(e.flow < e.capacity){
    if(dfs(g, pfrom, pto, e.to, sink, ved))return true;
    }
    }
    if(pfrom== cur && dfs(g, pfrom, pto, pto, sink, ved))return true;
    return false;
    }
    public static void main(String[] args) throws Exception
    {
    // int n = 1000, m = 10000;
    // Random gen = new Random();
    // StringBuilder sb = new StringBuilder();
    // sb.append(n + " ");
    // sb.append(m + " ");
    // sb.append(1 + " ");
    // sb.append(n + " ");
    // for (int i = 0; i < m; i++) {
    // sb.append(gen.nextInt(n)+1 + " ");
    // sb.append(gen.nextInt(n)+1 + " ");
    // }
    // sb.append("0 0 0 0");
    // INPUT = sb.toString();
    long S = System.currentTimeMillis();
    is = INPUT.isEmpty() ? System.in : new ByteArrayInputStream(INPUT.getBytes());
    out = new PrintWriter(System.out);
    solve();
    out.flush();
    long G = System.currentTimeMillis();
    tr(G-S+"ms");
    }
    private static boolean eof()
    {
    if(lenbuf == -1)return true;
    int lptr = ptrbuf;
    while(lptr < lenbuf)if(!isSpaceChar(inbuf[lptr++]))return false;
    try {
    is.mark(1000);
    while(true){
    int b = is.read();
    if(b == -1){
    is.reset();
    return true;
    }else if(!isSpaceChar(b)){
    is.reset();
    return false;
    }
    }
    } catch (IOException e) {
    return true;
    }
    }
    private static byte[] inbuf = new byte[1024];
    static int lenbuf = 0, ptrbuf = 0;
    private static int readByte()
    {
    if(lenbuf == -1)throw new InputMismatchException();
    if(ptrbuf >= lenbuf){
    ptrbuf = 0;
    try { lenbuf = is.read(inbuf); } catch (IOException e) { throw new InputMismatchException(); }
    if(lenbuf <= 0)return -1;
    }
    return inbuf[ptrbuf++];
    }
    private static boolean isSpaceChar(int c) { return !(c >= 33 && c <= 126); }
    // private static boolean isSpaceChar(int c) { return !(c >= 32 && c <= 126); }
    private static int skip() { int b; while((b = readByte()) != -1 && isSpaceChar(b)); return b; }
    private static double nd() { return Double.parseDouble(ns()); }
    private static char nc() { return (char)skip(); }
    private static String ns()
    {
    int b = skip();
    StringBuilder sb = new StringBuilder();
    while(!(isSpaceChar(b))){
    sb.appendCodePoint(b);
    b = readByte();
    }
    return sb.toString();
    }
    private static char[] ns(int n)
    {
    char[] buf = new char[n];
    int b = skip(), p = 0;
    while(p < n && !(isSpaceChar(b))){
    buf[p++] = (char)b;
    b = readByte();
    }
    return n == p ? buf : Arrays.copyOf(buf, p);
    }
    private static char[][] nm(int n, int m)
    {
    char[][] map = new char[n][];
    for(int i = 0;i < n;i++)map[i] = ns(m);
    return map;
    }
    private static int[] na(int n)
    {
    int[] a = new int[n];
    for(int i = 0;i < n;i++)a[i] = ni();
    return a;
    }
    private static int ni()
    {
    int num = 0, b;
    boolean minus = false;
    while((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'));
    if(b == '-'){
    minus = true;
    b = readByte();
    }
    while(true){
    if(b >= '0' && b <= '9'){
    num = num * 10 + (b - '0');
    }else{
    return minus ? -num : num;
    }
    b = readByte();
    }
    }
    private static long nl()
    {
    long num = 0;
    int b;
    boolean minus = false;
    while((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'));
    if(b == '-'){
    minus = true;
    b = readByte();
    }
    while(true){
    if(b >= '0' && b <= '9'){
    num = num * 10 + (b - '0');
    }else{
    return minus ? -num : num;
    }
    b = readByte();
    }
    }
    private static void tr(Object... o) { if(INPUT.length() != 0)System.out.println(Arrays.deepToString(o)); }
    }
