    #include <cstdio>
    #include <algorithm>
    #include <vector>
    #include <cstdlib>
    #include <string>
    #include <cstring>
     
    using namespace std;
    typedef vector<int> ivec;
     
    int N, M, T;
    int Pi[100], Ti[100], Ki[100];
    bool see[100];
    ivec graph[100];
     
    bool wf[100][100];
    int scc[100];
    bool calc[100];
     
    // new env
    ivec X[100], Y[100], Z[100];
    ivec con[100];
     
    int dp[100][10100];
     
    void update(int p, int cs, int pr)
    {
    for (int i = T; i >= cs; --i) {
    dp[p][i] = max(dp[p][i], dp[p][i - cs] + pr);
    }
    }
     
    void solve(int p)
    {
    if (calc[p]) return;
    calc[p] = true;
     
    for (int q : con[p]) solve(q);
     
    for (int j = 0; j <= T; ++j) dp[p][j] = 0;
     
    for (int q : con[p]) {
    for (int j = 0; j <= T; ++j) dp[p][j] = max(dp[p][j], dp[q][j]);
    }
     
    for (int i = 0; i < X[p].size(); ++i) {
    int sz = Z[p][i];
     
    for (int j = 1; j <= sz; j *= 2) {
    update(p, Y[p][i] * j, X[p][i] * j);
    sz -= j;
    }
     
    if (sz > 0) {
    update(p, Y[p][i] * sz, X[p][i] * sz);
    }
    }
    }
     
    int main()
    {
    for (;;) {
    scanf("%d%d%d", &N, &M, &T);
    if (N == 0) break;
    for (int i = 0; i < N; ++i) {
    scanf("%d%d%d", Pi + i, Ti + i, Ki + i);
    see[i] = false;
    graph[i].clear();
    scc[i] = -1;
     
    X[i].clear(); Y[i].clear(); Z[i].clear();
    con[i].clear();
    calc[i] = false;
    }
     
    for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) wf[i][j] = i == j;
     
    for (int i = 0; i < M; ++i) {
    int u, v;
    scanf("%d%d", &u, &v);
    --u; --v;
     
    wf[u][v] = true;
     
    if (u == v) {
    see[u] = true;
    }
    else {
    graph[u].push_back(v);
    }
    }
     
    for (int i = 0; i < N; ++i) for (int j = 0; j < N; ++j) for (int k = 0; k < N; ++k) wf[j][k] |= wf[j][i] & wf[i][k];
     
    int C = 0;
    for (int i = 0; i < N; ++i) if (scc[i] == -1) {
    int sz = 1;
    for (int j = i + 1; j < N; ++j) if (scc[j] == -1 && wf[i][j] && wf[j][i]) {
    scc[j] = C;
    ++sz;
    }
    scc[i] = C++;
     
    if (sz >= 2) {
    for (int j = 0; j < N; ++j) if (scc[j] == scc[i]) see[j] = true;
    }
    }
     
    for (int i = 0; i < N; ++i) {
    if (!see[i]) Ki[i] = 1;
    int p = scc[i];
    X[p].push_back(Pi[i]);
    Y[p].push_back(Ti[i]);
    Z[p].push_back(Ki[i]);
     
    for (int q : graph[i]) if (scc[i] != scc[q]) con[scc[i]].push_back(scc[q]);
    }
     
    for (int i = 0; i < C; ++i) solve(i);
    int ret = 0;
    for (int i = 0; i < C; ++i) for (int j = 0; j <= T; ++j) ret = max(ret, dp[i][j]);
     
    printf("%d\n", ret);
    }
     
    return 0;
    }
